# Class TableWebElement

The component WebElement for oj-c-table. Do not instantiate this class directly, instead, use findTable.

#### Hierarchy

- TableWebElementBase
  - TableWebElement

#####
Index

### Constructors

constructor

### Methods

changeColumnOrder
changeColumnWidths
changeSelected
clear
click
doRowAction
findCell
findElement
findElements
findFooter
findHeader
findNoData
getAttribute
getColumnOrder
getColumnWidths
getColumns
getCssValue
getCurrentCell
getCurrentCellOverride
getDriver
getHorizontalGridVisible
getId
getLayout
getLocation
getProperty
getRect
getRow
getScrollPolicyOptions
getSelectAllControl
getSelected
getSelectionMode
getShadowRoot
getSize
getTagName
getText
getVerticalGridVisible
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new TableWebElement(el, locators): TableWebElement

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns TableWebElement

  Inherited from TableWebElementBase.constructor

## Methods

### changeColumnOrder

- changeColumnOrder(columnOrder): Promise<void>

- Sets the value of `columnOrder` property. Display and order of columns. See the Help documentation for more information.

  #### Parameters

  - ##### columnOrder: string[]

    The value to set for `columnOrder`

  #### Returns Promise<void>

  Inherited from TableWebElementBase.changeColumnOrder

### changeColumnWidths

- changeColumnWidths(columnWidths): Promise<void>

- Sets the value of `columnWidths` property. The desired widths of table columns. A record mapping column keys to numbers representing pixel widths for each column.

  #### Parameters

  - ##### columnWidths: object

    The value to set for `columnWidths`

  #### Returns Promise<void>

  Inherited from TableWebElementBase.changeColumnWidths

### changeSelected

- changeSelected<K, C>(selected): Promise<void>

- Sets the value of "selected" property. If row/column are both unspecified selected for both will be empty. If no object is set on row/column, selected for that axis will be empty. If 'all' is unset for row/column object only 'keys' will be considered, if no 'keys' are specified selected for that axis will be empty. See the Help documentation for more information.

  #### Type Parameters

  - #### K

  - #### C

  #### Parameters

  - ##### selected: {
    column: {
    all: true;
    deletedKeys: C[];
    keys?: undefined;
    } | {
    all: false;
    deletedKeys?: undefined;
    keys: C[];
    };
    row: {
    all: true;
    deletedKeys: K[];
    keys?: undefined;
    } | {
    all: false;
    deletedKeys?: undefined;
    keys: K[];
    };
    }

    The value to set for "selected"

    - ##### column: {
      all: true;
      deletedKeys: C[];
      keys?: undefined;
      } | {
      all: false;
      deletedKeys?: undefined;
      keys: C[];
      }

    - ##### row: {
      all: true;
      deletedKeys: K[];
      keys?: undefined;
      } | {
      all: false;
      deletedKeys?: undefined;
      keys: K[];
      }

  #### Returns Promise<void>

  #### Typeparam

  K Type of keys

  Overrides TableWebElementBase.changeSelected

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from TableWebElementBase.clear

### click

- click(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from TableWebElementBase.click

### doRowAction

- doRowAction<K>(itemLocator): Promise<void>

- Set a given row active. Triggers a ojRowAction Event.

  #### Type Parameters

  - #### K

  #### Parameters

  - ##### itemLocator: {
    rowKey: K;
    }

    - ##### rowKey: K

      The rowKey associated with the row.

  #### Returns Promise<void>

### findCell

- findCell<K, C>(itemLocator): Promise<SlotProxy>

- Retrieve a SlotProxy which represents a cell. Cell content is only retrievable if there is a cell template for the cell. Throws if there is no matching cell or if there is not cell template for the cell.

  #### Type Parameters

  - #### K

  - #### C

  #### Parameters

  - ##### itemLocator: {
    columnKey: C;
    rowKey: K;
    }

    - ##### columnKey: C

      The columnKey associated with the cell

    - ##### rowKey: K

      The rowKey associated with the cell

  #### Returns Promise<SlotProxy>

### findElement

- findElement(locator): WebElementPromise

- #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  #### Inherit Doc

  Inherited from TableWebElementBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  #### Inherit Doc

  Inherited from TableWebElementBase.findElements

### findFooter

- findFooter<C>(itemLocator): Promise<SlotProxy>

- Retrieve a SlotProxy which represents a footer cell. Footer content is only retrievable if there is a footer template for the cell. Throws if there is no matching footer or if there is not footer template for the cell.

  #### Type Parameters

  - #### C

  #### Parameters

  - ##### itemLocator: {
    columnKey: C;
    }

    - ##### columnKey: C

      The columnKey associated with the footer cell

  #### Returns Promise<SlotProxy>

### findHeader

- findHeader<C>(itemLocator): Promise<SlotProxy>

- Retrieve a SlotProxy which represents a header cell. Header content is only retrievable if there is a header template for the cell. Throws if there is no matching header or if there is not header template for the cell.

  #### Type Parameters

  - #### C

  #### Parameters

  - ##### itemLocator: {
    columnKey: C;
    }

    - ##### columnKey: C

      The columnKey associated with the header cell

  #### Returns Promise<SlotProxy>

### findNoData

- findNoData(): Promise<SlotProxy>

- Retrieve a SlotProxy which represents no data content.

  #### Returns Promise<SlotProxy>

### getAttribute

- getAttribute(attributeName): Promise<string>

- #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from TableWebElementBase.getAttribute

### getColumnOrder

- getColumnOrder(): Promise<string[]>

- Gets the value of `columnOrder` property. Display and order of columns. See the Help documentation for more information.

  #### Returns Promise<string[]>

  The value of `columnOrder` property.

  Inherited from TableWebElementBase.getColumnOrder

### getColumnWidths

- getColumnWidths(): Promise<object>

- Gets the value of `columnWidths` property. The desired widths of table columns. A record mapping column keys to numbers representing pixel widths for each column.

  #### Returns Promise<object>

  The value of `columnWidths` property.

  Inherited from TableWebElementBase.getColumnWidths

### getColumns

- getColumns(): Promise<object>

- Gets the value of `columns` property. The set of columns that can be displayed in the Table.

  #### Returns Promise<object>

  The value of `columns` property.

  Inherited from TableWebElementBase.getColumns

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from TableWebElementBase.getCssValue

### getCurrentCell

- getCurrentCell(): Promise<object>

- Gets the value of `currentCell` property. The cell currently being used as the target for keyboard gestures made on the Table.

  #### Returns Promise<object>

  The value of `currentCell` property.

  Inherited from TableWebElementBase.getCurrentCell

### getCurrentCellOverride

- getCurrentCellOverride(): Promise<object>

- Gets the value of `currentCellOverride` property. The cell override to apply to the current cell of the Table. In order for this property to be honored, a new object instance must be set.

  #### Returns Promise<object>

  The value of `currentCellOverride` property.

  Inherited from TableWebElementBase.getCurrentCellOverride

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from TableWebElementBase.getDriver

### getHorizontalGridVisible

- getHorizontalGridVisible(): Promise<string>

- Gets the value of `horizontalGridVisible` property. Controls the display of the Table's horizontal gridlines.

  #### Returns Promise<string>

  The value of `horizontalGridVisible` property.

  Inherited from TableWebElementBase.getHorizontalGridVisible

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from TableWebElementBase.getId

### getLayout

- getLayout(): Promise<string>

- Gets the value of `layout` property. The column sizing method used for the Table's columns.

  #### Returns Promise<string>

  The value of `layout` property.

  Inherited from TableWebElementBase.getLayout

### getLocation

- getLocation(): Promise<ILocation>

- #### Returns Promise<ILocation>

  #### Inherit Doc

  Inherited from TableWebElementBase.getLocation

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from TableWebElementBase.getProperty

### getRect

- getRect(): Promise<IRectangle>

- #### Returns Promise<IRectangle>

  #### Inherit Doc

  Inherited from TableWebElementBase.getRect

### getRow

- getRow(): Promise<Row>

- Gets the value of `row` property. A subset of attributes for controlling certain behaviors on a per row basis.

  #### Returns Promise<Row>

  The value of `row` property.

  Inherited from TableWebElementBase.getRow

### getScrollPolicyOptions

- getScrollPolicyOptions(): Promise<ScrollPolicyOptions>

- Gets the value of `scrollPolicyOptions` property. Options related to the Table's fetching and scrolling behaviors.

  #### Returns Promise<ScrollPolicyOptions>

  The value of `scrollPolicyOptions` property.

  Inherited from TableWebElementBase.getScrollPolicyOptions

### getSelectAllControl

- getSelectAllControl(): Promise<string>

- Gets the value of `selectAllControl` property. Controls the display of the Table's select all control when multiple row selection is enabled.

  #### Returns Promise<string>

  The value of `selectAllControl` property.

  Inherited from TableWebElementBase.getSelectAllControl

### getSelected

- getSelected<K, C>(): Promise<{
  column: {
  all: true;
  deletedKeys: C[];
  keys?: undefined;
  } | {
  all: false;
  deletedKeys?: undefined;
  keys: C[];
  };
  row: {
  all: true;
  deletedKeys: K[];
  keys?: undefined;
  } | {
  all: false;
  deletedKeys?: undefined;
  keys: K[];
  };
  }>

- Gets the value of "selected" property.

  #### Type Parameters

  - #### K

  - #### C

  #### Returns Promise<{
  column: {
  all: true;
  deletedKeys: C[];
  keys?: undefined;
  } | {
  all: false;
  deletedKeys?: undefined;
  keys: C[];
  };
  row: {
  all: true;
  deletedKeys: K[];
  keys?: undefined;
  } | {
  all: false;
  deletedKeys?: undefined;
  keys: K[];
  };
  }>

  The value of "selected" property.

  #### Typeparam

  K Type of keys

  Overrides TableWebElementBase.getSelected

### getSelectionMode

- getSelectionMode(): Promise<SelectionMode>

- Gets the value of `selectionMode` property. Specifies whether row and/or column selection gestures are enabled on the Table, and the cardinality of each (single/multiple/none).

  #### Returns Promise<SelectionMode>

  The value of `selectionMode` property.

  Inherited from TableWebElementBase.getSelectionMode

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from TableWebElementBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- #### Returns Promise<ISize>

  #### Inherit Doc

  Inherited from TableWebElementBase.getSize

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from TableWebElementBase.getTagName

### getText

- getText(): Promise<string>

- #### Returns Promise<string>

  #### Inherit Doc

  Inherited from TableWebElementBase.getText

### getVerticalGridVisible

- getVerticalGridVisible(): Promise<string>

- Gets the value of `verticalGridVisible` property. Controls the display of the Table's vertical gridlines.

  #### Returns Promise<string>

  The value of `verticalGridVisible` property.

  Inherited from TableWebElementBase.getVerticalGridVisible

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  #### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  Inherited from TableWebElementBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  #### Returns Condition<Promise<boolean>>

  #### Deprecated

  Inherited from TableWebElementBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from TableWebElementBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from TableWebElementBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from TableWebElementBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from TableWebElementBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from TableWebElementBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from TableWebElementBase.setProperty

### submit

- submit(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from TableWebElementBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from TableWebElementBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from TableWebElementBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from TableWebElementBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from TableWebElementBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from TableWebElementBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  #### Throws

  if the object is not a valid encoded ID.

  Inherited from TableWebElementBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from TableWebElementBase.isId

Generated using TypeDoc